(**************************************************************************)
(*             Certified Calculus of Inductive Constructions              *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL FREE SOFTWARE LICENSE, version 2.   *)
(**************************************************************************)

Require Export Vect.

Set Implicit Arguments.
Unset Strict Implicit.

  (* The subtyping relation *)

Transparent sort.
(* Il faut que tous les sigma soient autorise's pour pouvoir typer 
   l'application (entre autres) librement. *)
Definition ax : sort -> sort -> Prop := axiom_v6.
Definition incl_sort : sort -> sort -> Prop := univ_v6.
Definition pr : sort -> sort -> sort -> Prop := pairs_v6.
Definition rl : sort -> sort -> sort -> Prop := rules_v6.
Lemma so_typed : in_dom_rel ax so.
Proof.
split with (Stype 0).
unfold so in |- *.
constructor.
Qed.
Lemma all_prod : forall s1 s2, exists s3 : _, pr s1 s2 s3.
Proof v6_all_pair.
Lemma univ_hierarchy :
 forall s1 s2,
 clos_refl_trans _ incl_sort s1 s2 -> in_dom_rel ax s2 -> in_dom_rel ax s1.
Proof v6_hierarchy.
Opaque sort.


(* Cumulativity *)

  Inductive cumul : red_rule :=
      Cumul_intro : forall e s1 s2, incl_sort s1 s2 -> cumul e %%s1 %%s2.

  Lemma R_lift_cumul : R_lift cumul.
Proof.
red in |- *; intros.
inversion_clear H.
simpl in |- *.
constructor; auto.
Qed.


  Lemma R_subst_cumul : R_subst cumul.
Proof.
red in |- *; intros.
inversion_clear H.
simpl in |- *.
constructor; auto.
Qed.


  Lemma stable_cumul : forall R, R_stable R cumul.
Proof.
red in |- *.
simple destruct 1; intros.
constructor; auto.
Qed.


  Hint Resolve Cumul_intro: core.

