(**************************************************************************)
(*             Certified Calculus of Inductive Constructions              *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL FREE SOFTWARE LICENSE, version 2.   *)
(**************************************************************************)

Require Import CoreDec.
Require Import SignCorrectness.

Set Implicit Arguments.
Unset Strict Implicit.

  Section IFixDecOk.

    Context {sg : sigma}.
    Context {sgn_ok : sign_ok}.


    (* Typing fixpoints is decidable *)

    Lemma sign_dec_fixp :
      forall e m t,
        ⊦ (e; x_ := m : t) ->
          ppal_dec (fun u => in_sign_sat Fixp e m t u) (cci_subtype e).
    Proof.
      intros.
      elim dest_cst_pair with e m t;
        [ intros (((tys, ar), (bds, tybds)), (eqp, (redt, (wf_ar, wf_bds))))
          | Right_Neg
          | trivial ].
      rewrite eqp; clear eqp H m.
      elim red_to_sort_dec with e ar;
        [ intros (s, redar) | right; red in |- *; intros | idtac ].
      generalize (is_fix_types_dec tys).
      intros [(fds, eqtys)| not_fix_tys].
      rewrite eqtys; rewrite eqtys in wf_ar; clear eqtys tys.
      cut (⊦ (e; x_ : fix_bodies x_ fds)).
      intro wf_fb.
      elim subtype_dec with e tybds (fix_bodies x_ fds); intros.
      left.
      split with (fix_types fds).
      split; intros.
      split with (%%s ** fix_bodies x_ fds).
      split.
      change_notation; apply cci_trans with (ar ** tybds); auto.

      apply all_prod_sum; trivial.
      apply (subj_red_wf (forget_def _ _ _ _ wf_ar) redar).

      split.
      constructor.

      apply wf_var with s.
      apply subj_red_ty with (2 := redar).
      Inversion_typ wf_ar; trivial.

      InvSignSat H ipattern:ty; auto.

      right; red in |- *; intros.
      apply b.
      generalize (fix_types_inj (fd1:=fds)).
      InvSignSat H ipattern:ty; intros.
      rewrite H1 with fixdefs; trivial.
      apply cci_trans with (fix_bodies m fixdefs).
      apply (inv_sum_r (cci_trans (eq_term_sym_cci_sub (redn_conv redt)) H)).

      apply eq_term_cci_sub.
      apply eq_term_step.
      unfold fix_bodies in |- *.
      do 2 right; left; constructor.

      eapply ok_gs_inj; eassumption.
      apply ok_normalize.
      eapply var_wft, forget_def; eassumption.

      apply ok_normalize.
      apply var_wft; trivial.

      apply typ_fix_correctness.
      apply wf_var with s.
      apply subj_red_ty with (2 := redar).
      Inversion_typ wf_ar; trivial.

      right; red in |- *; intros.
      generalize not_fix_tys.
      InvSignSat H ipattern:ty; intros.
      elim not_fix_tys0 with fixdefs; trivial.

      InvSignSat H ipattern:ty; intros.
      elim b with s.
      apply (inv_sum_l (cci_trans (eq_term_sym_cci_sub (redn_conv redt)) H)).

      eapply var_wft, forget_def; eassumption.

      InvSignSat H0 ipattern:ty; intros.
      prolog [ ex_intro ex_intro2 refl_equal ] 10.
    Qed.

  End IFixDecOk.
