(**************************************************************************)
(*             Certified Calculus of Inductive Constructions              *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL FREE SOFTWARE LICENSE, version 2.   *)
(**************************************************************************)

Require Export CicCore.

Set Implicit Arguments.
Unset Strict Implicit.

(*
  Definition cst: cci_op->(cterm (0)).
Intro op.
Split with (Cst0 op).
Constructor.
Defined.

  Coercion cst: cci_op >-> (cterm (0)).
*)
  Coercion Cst0 : oper >-> term.

  Transparent sort.
  Definition so : sort := Sprop Neg.
  Opaque sort.

  Definition oper_id : cci_op -> oper := fun x => x.

  Coercion oper_id : cci_op >-> oper.

  Definition unit : term := Nil_mark.
  Definition one : term := Lmark.

  Lemma unit_not_pair : forall a b, unit <> (a,,b).
Proof.
intros.
discriminate.
Qed.

  Fixpoint mkvect (l : list term) : term :=
    match l with
    | nil => one
    | x :: l' => x ** mkvect l'
    end.


  Lemma is_vect_dec :
   forall t, {l : _ | t = mkvect l} + {(forall l, t <> mkvect l)}.
Proof.
(*Realizer Fix is_vect
 {is_vect [t:?]: ? :=
    if (term_eq t (Cst0 one)) then (inleft ? (nil term))
    else Cases t of
           (Sum a b) => Cases (is_vect b) of
                          (inleft l) => (inleft ? (cons ? a l))
                        | _ => (inright (list term))
                        end
         | _ => (inright (list term))
         end}.*)
fix is_vect 1.
intros [s| n| c| c u| x a b| x a m| a b| u v];
 try
  (right; red in |- *; intros [| h l]; simpl in |- *; intros eq_t;
    discriminate).
case c;
 (left; exists (nil (A:=term)); reflexivity) ||
   (right; red in |- *; intros [| h' l']; simpl in |- *; intros eq_t;
     discriminate).    

case (is_vect b).
intros (l, l_vect); subst b.
left; exists (a :: l); reflexivity.

intros not_vect; red in not_vect.
right; red in |- *; intros [| h' l']; simpl in |- *; intros eq_sum;
 discriminate || (injection eq_sum; intros; subst b; eauto).
Defined.

  Lemma mkvect_lift :
   forall n l k, ^(n//k)(mkvect l) = mkvect (map (fun t => ^(n//k)t) l).
Proof.
simple induction l; simpl in |- *; intros; auto.
rewrite <- H; trivial.
Qed.

  Lemma mkvect_subst :
   forall s l k, (mkvect l)[k:=s] = mkvect (map (fun t => t[k:=s]) l).
Proof.
simple induction l; simpl in |- *; intros; auto.
rewrite <- H; trivial.
Qed.


  Fixpoint mktuple (l : list term) : term :=
    match l with
    | nil => unit:term
    | t :: l' => t,,mktuple l'
    end.

  Lemma lift_mktuple :
   forall n l k, ^(n//k)(mktuple l) = mktuple (map (fun t => ^(n//k)t) l).
Proof.
simple induction l; simpl in |- *; intros; auto.
rewrite <- H; trivial.
Qed.

  Lemma subst_mktuple :
   forall s l k, (mktuple l)[k:=s] = mktuple (map (fun t => t[k:=s]) l).
Proof.
simple induction l; simpl in |- *; intros; auto.
rewrite <- H; trivial.
Qed.
