(**************************************************************************)
(*               Certified Pure Type Systems with Operators               *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL free software license, version 2.   *)
(**************************************************************************)

Set Implicit Arguments.
Unset Strict Implicit.

  Definition decide P := {P} + {~ P}.

  Definition dec_find (A : Set) P := {x : A | P x} + {(forall x, ~ P x)}.

  Hint Unfold decide dec_find: core.


Section Principal.

  Variables (A : Set) (P : A -> Prop) (R : A -> A -> Prop).

  Unset Elimination Schemes.

  Record ppal (x : A) : Prop := Pp_intro
    {pp_ok : P x; pp_least : forall y, P y -> R x y}.

  Definition ppal_dec := {x : _ | ppal x} + {(forall x, ~ P x)}.

End Principal.

  Lemma ppal_dec_unique :
   forall (A : Set) P,
   ppal_dec P (eq (A:=_)) -> forall x y : A, P x -> P y -> x = y.
Proof.
intros A P [(z, (z_ok, z_lst))| absurd] x y px py.
transitivity z; auto.
symmetry  in |- *; auto.

elim absurd with x; trivial.
Qed.
