(**************************************************************************)
(*               Certified Pure Type Systems with Operators               *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL free software license, version 2.   *)
(**************************************************************************)

Set Implicit Arguments.
Unset Strict Implicit.

Implicit Arguments Some [A].

Section OptionType.

  Variable A : Set.

  Definition outSome : forall ox, ox <> None (A:=A) -> A.
simple destruct ox.
intros a _; exact a.

intros.
elim H; trivial.
Defined.

  Variable R : A -> A -> Prop.

  Inductive rel_option : option A -> option A -> Prop :=
    | Rel_op_some : forall x y, R x y -> rel_option (Some x) (Some y)
    | Rel_op_none : rel_option None None.


End OptionType.

  Hint Resolve Rel_op_none Rel_op_some: core.


  Definition app_option (A B : Set) (f : A -> B) (x : option _) :=
    match x with
    | Some a => Some (f a)
    | None => None (A:=B)
    end.
