(**************************************************************************)
(*               Certified Pure Type Systems with Operators               *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL free software license, version 2.   *)
(**************************************************************************)

Require Export MlPrint.
Require Export General.

Class has_eq_dec A :=
  eq_dec : forall (x y : A), decide (x = y).

Instance eq_dec_nat : has_eq_dec nat.
Proof eq_nat_dec.

Instance eq_dec_list A : has_eq_dec A -> has_eq_dec (list A).
Proof.
  repeat (hnf; intros).
  decide equality; apply eq_dec.
Defined.


Notation "x == y" := (eq_dec x y) (at level 70, no associativity).

Module Type PTSPARAMS.
  Parameter name : Set.
  Parameter x_ : name.
  Declare Instance eq_dec_name : has_eq_dec name.
  Parameter oper : Set.
  Declare Instance eq_dec_oper : has_eq_dec oper.
  Parameter sort : Set.
  Declare Instance eq_dec_sort : has_eq_dec sort.
End PTSPARAMS.
