(**************************************************************************)
(*               Certified Pure Type Systems with Operators               *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL free software license, version 2.   *)
(**************************************************************************)

Require Export Env.

Module Type IPTS_spec
  (Import P : PTSPARAMS)
  (Import MTermes : ITermes P)
  (Import MEnv : IEnv P MTermes).


Definition sign_relation := oper -> env -> term -> term -> term -> Prop.

Class InvariantSignature (in_sign : sign_relation) (R : red_rule) := {

  in_sign_lift :
    forall c e f g d k m t u,
      ins_in_env g d k e f ->
      in_sign c e m t u -> in_sign c f ^(1//k)m ^(1//k)t ^(1//k)u;

  in_sign_subst :
    forall c e f g d k s m t u,
      sub_in_env g s d k e f ->
      in_sign c e m t u -> in_sign c f m[k:=s] t[k:=s] u[k:=s];

  in_sign_stable :
    forall c e f m t u,
      rel_in_list (rel_typ R) e f -> in_sign c f m t u -> in_sign c e m t u

}.



Class PTSO_spec := {

  axiom : sort -> sort -> Prop;
  rule : sort -> sort -> sort -> Prop;
  prd : sort -> sort -> sort -> Prop;
  subrule : Subtyping_rule;
  in_sign0 : oper -> term -> Prop;
  in_sign1 : sign_relation;

  pts_is_sign : InvariantSignature in_sign1 (Rule subrule)

}.

Existing Instance pts_is_sign.

End IPTS_spec.
