(**************************************************************************)
(*             Certified Calculus of Inductive Constructions              *)
(*                                                                        *)
(*                     Bruno Barras, Stéphane Glondu                      *)
(*                                                                        *)
(*                           © 1999-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL FREE SOFTWARE LICENSE, version 2.   *)
(**************************************************************************)

let () =
  Arg.parse
    [ "-debug", Arg.Set Clflags.debug, "Debug mode" ]
    (fun s -> Printf.ksprintf (fun x -> raise (Arg.Bad x)) "invalid argument: %s" s)
    "Usage: bcoq [-debug]"
;;

Checker.prelude();;

Sys.catch_break true;;

let rec loop() =
  try Checker.go()
  with
    Sys.Break -> print_endline "Interruption."; loop()
  | Stack_overflow -> print_endline "Debordement de pile"; loop()
;;

loop();;
