(**************************************************************************)
(*                       The Extracted Coq subsytem                       *)
(*                                                                        *)
(*                            Stéphane Glondu                             *)
(*                                                                        *)
(*                           © 2007-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL FREE SOFTWARE LICENSE, version 2.   *)
(**************************************************************************)

type 'a constr = {
  interp : Term.constr -> 'a option;
  reify : 'a -> Term.constr;
  constr : Term.constr Lazy.t;
}

val nat : Kernel.nat constr
val bool : bool constr
val string : string constr
val list : 'a constr -> 'a list constr
val option : 'a constr -> 'a option constr

val ml_string : string constr
val sort : Kernel.CicCore.sort constr
val term : Kernel.CicCore.term constr
val cterm : Kernel.nat -> Kernel.CicCore.term constr
val cdecl : Kernel.nat -> Kernel.CicCore.cdecl constr
val constructor : Kernel.constructor constr
val one_ind : Kernel.one_ind constr
val constant_obj : Kernel.constant_obj constr
val sig_item : Kernel.sig_item constr
