(**************************************************************************)
(*                       The Extracted Coq subsytem                       *)
(*                                                                        *)
(*                            Stéphane Glondu                             *)
(*                                                                        *)
(*                           © 2007-2011 INRIA                            *)
(*                                                                        *)
(*  This program is free software; you can redistribute it and/or modify  *)
(*   it under the terms of the CeCILL FREE SOFTWARE LICENSE, version 2.   *)
(**************************************************************************)

(** This is a fully-qualifiable alias for OCaml's [string] type, for
    use in extracted code (where [string] is shadowed by Coq's
    one). *)
type ml_string = string

(** [mk_str]: realizer for Coq's [MlString.mk_str]. Creates a ML
    string from a Coq string. The argument should be the extraction of
    a Coq string (no checks are performed). *)
val mk_str : 'a -> ml_string

(** [mk_int]: realizer for [MlInteger.int]. *)
val mk_int : 'a -> Big_int.big_int
