Declare ML Module "xcoq".

Require Import List.
Require Import Ascii String.
Require Import Extraction.

XBoot (1::2::3::4::5::nil).
XBoot 1.
XBoot "Hello world!"%string.

(* Inductive True : Prop := I : True. *)

Definition dTrue := MutInductive (
  {|
    i_name := mk_str "True";
    i_param := mk_cterm _ Lmark;
    i_arg := mk_cterm _ Lmark;
    i_ckind := so;
    i_kind := so;
    i_constrs := Some (
      {|
        c_name := mk_str "I";
        c_arg := mk_cterm _ Lmark;
        c_inst := mk_cterm _ Nil_mark
      |} :: nil
    )
  |} :: nil
).

Definition xTrue :=
  Ind {mk_str "True" // Nil_mark,, Nil_mark,, Nil_mark}.
Definition xI :=
  Cstr {mk_str "I" // Nil_mark,, Nil_mark}.

XBoot dTrue.
XDeclare dTrue.
XCheck xTrue.
XCheck xI.

(* Inductive False : Prop :=. *)

Definition dFalse := MutInductive (
  {|
    i_name := mk_str "False";
    i_param := mk_cterm _ Lmark;
    i_arg := mk_cterm _ Lmark;
    i_ckind := so;
    i_kind := so;
    i_constrs := Some nil
  |} :: nil
).

Definition xFalse :=
  Ind {mk_str "False" // Nil_mark,, Nil_mark,, Nil_mark}.

XBoot dFalse.
XDeclare dFalse.
XCheck xFalse.

(* Definition not (A:Prop) := A -> False. *)

Definition dnot := Constant {|
  c_par := mk_cterm _ Lmark;
  c_decl := {|
    dNAME := mk_str "not";
    dTYPE := mk_cterm _ (Forall (mk_str "A") : %%so, %%so);
    dBODY := Some (mk_cterm 1 (
      Fun (mk_str "A") : %%so =>
      Forall (mk_str "_") : #0,
      Ind {mk_str "False" // Nil_mark,, Nil_mark,, Nil_mark}
    ))
  |}
|}.

Definition xnot :=
  Cst1 (Const (mk_str "not")) Nil_mark.

XBoot dnot.
XDeclare dnot.
XCheck (xnot @ xTrue).

(* Inductive and (A B:Prop) : Prop := conj : A -> B -> A /\ B *)

Definition dand := MutInductive (
  {|
    i_name := mk_str "and";
    i_param := mk_cterm _ (%%so ** %%so);
    i_arg := mk_cterm _ Lmark;
    i_ckind := so;
    i_kind := so;
    i_constrs := Some (
      {|
        c_name := mk_str "conj";
        c_arg := mk_cterm 1 ((#0)..L ** (#0)..R);
        c_inst := mk_cterm _ Nil_mark
      |} :: nil
    )
  |} :: nil
).

Definition xand t u :=
  Ind {mk_str "and" // (t,, u),, Nil_mark,, Nil_mark}.
Definition xconj t u t' u' :=
  Cstr {mk_str "conj" // (t,, u),, (t',, u')}.

XBoot dand.
XDeclare dand.
XCheck (xand xTrue xFalse).
XCheck (xconj xTrue xTrue xI xI).

Definition dproj1 := Constant {|
  c_par := mk_cterm _ (%%so ** %%so);
  c_decl := {|
    dNAME := mk_str "proj1";
    dTYPE := mk_cterm 1 (
      Forall (mk_str "H") : xand (#0)..L (#0)..R, (#1)..L
    );
    dBODY := None
  |}
|}.

Definition xproj1 t u :=
  Cst1 (Const (mk_str "proj1")) (t,, u).

XDeclare dproj1.
XCheck (xproj1 xTrue xFalse).

Definition dproj2 := Constant {|
  c_par := mk_cterm _ (%%so ** %%so);
  c_decl := {|
    dNAME := mk_str "proj2";
    dTYPE := mk_cterm 1 (
      Forall (mk_str "H") : xand (#0)..L (#0)..R, (#1)..R
    );
    dBODY := None
  |}
|}.

Definition xproj2 t u :=
  Cst1 (Const (mk_str "proj2")) (t,, u).

XDeclare dproj2.
XCheck (xproj2 xTrue xFalse).

(*
Inductive or (A B:Prop) : Prop :=
  | or_introl : A -> A \/ B
  | or_intror : B -> A \/ B
where "A \/ B" := (or A B) : type_scope.
*)

Definition dor := MutInductive (
  {|
    i_name := mk_str "or";
    i_param := mk_cterm _ (%%so ** %%so);
    i_arg := mk_cterm _ Lmark;
    i_ckind := so;
    i_kind := so;
    i_constrs := Some (
      {|
        c_name := mk_str "or_introl";
        c_arg := mk_cterm 1 ((#0)..L);
        c_inst := mk_cterm _ Nil_mark
      |} ::
      {|
        c_name := mk_str "or_intror";
        c_arg := mk_cterm 1 ((#0)..R);
        c_inst := mk_cterm _ Nil_mark
      |} :: nil
    )
  |} :: nil
).

Definition xor t u :=
  Ind {mk_str "or" // (t,, u),, Nil_mark,, Nil_mark}.
Definition xor_introl t u v :=
  Cstr {mk_str "or_introl" // (t,, u),, v}.
Definition xor_intror t u v :=
  Cstr {mk_str "or_intror" // (t,, u),, v}.

XBoot dor.
XDeclare dor.
XCheck (xor xTrue xFalse).
XCheck (xor_introl xTrue xFalse xI).
XCheck (xor_intror xFalse xTrue xI).
